=== dev/test/tuple_algorithms/CMakeLists.txt ===
set(UNITTEST _unit.test.tuple_algorithms)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)
